##############################################################################
#
# Copyright (c) 2003-2005 struktur AG and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""
$Id: test_tool.py 14749 2005-12-08 16:49:53Z dreamcatcher $
"""

import os, sys

if __name__ == '__main__':
    execfile(os.path.join(os.path.dirname(sys.argv[0]), 'framework.py'))

# Load fixture
from Testing import ZopeTestCase
from base import BaseTest
from cStringIO import StringIO
from Products.CMFCore.utils import getToolByName

class SquidPathTest(BaseTest):

    def afterSetUp(self):
        BaseTest.afterSetUp(self)
        self.loginPortalOwner()
        self.qi = getToolByName(self.portal, 'portal_quickinstaller')
        self.qi.installProduct('CMFSquidTool')
        self.make_structure()

    def make_structure(self):
        portal = self. portal
        portal.invokeFactory('Folder', id='public_website')
        portal.public_website.invokeFactory('Folder', id='en')
        portal.public_website.en.invokeFactory('Document', id='index_html')

    def test_rewriteurl(self):
        from Products.CMFSquidTool.SquidTool import URL_REWRITE_MAP
        original= 'public_website/en'
        modified= ''
        URL_REWRITE_MAP[original] = modified

        portal = self.portal
        st = getToolByName(portal, 'portal_squid')
        ut = getToolByName(portal, 'portal_url')
        content = portal.public_website.en.index_html
        url = ut.getRelativeUrl(content)
        self.failUnless(st.rewriteUrl(url) == modified+'/index_html')

    def test_purgeurl(self):
        # SquidTool should not block purging an non existing url
        portal = self.portal
        st = getToolByName(portal, 'portal_squid')
        st.manage_setSquidSettings(urls="http://localhost")
        result = st.pruneUrls(ob_urls=['with_no_url'])
        # 0 if no apache is running, 400 tried to purge, but did not find url
        self.failUnless(result[0][0] in (0, 400))

    def test_compute_purgeurl(self):
        # If passed a complete url, computePurgeUrls should work just right.
        portal = self.portal
        st = getToolByName(portal, 'portal_squid')
        st.manage_setSquidSettings(urls="http://localhost/foo")
        result = st.computePurgeUrls(['http://other/bar/with_url'])
        self.assertEquals(result, ['http://localhost/foo/bar/with_url'])

def test_suite():
    import unittest
    suite = unittest.TestSuite()
    for testClass in (
        SquidPathTest,
                      ):
        suite.addTest(unittest.makeSuite(testClass))
    return suite

if __name__ == '__main__':
    framework(descriptions=1, verbosity=1)
